package lamda.consumer;

import lamda.pojo.Employee;

import java.awt.*;
import java.util.ArrayList;
import java.util.List;
import java.util.Objects;
import java.util.function.BiConsumer;
import java.util.function.Consumer;
import java.util.function.Predicate;

/**
 * Consumer gives input argument to any operation
 * doesn't return anything
 */

public class ConsumerExample {

    public static void main(String[] args) {

        //Basic start
        Consumer<Integer> data = System.out::println;
        data.accept(123);


        //Employee List
        List<Employee> empList = new ArrayList<>();
        empList.add(new Employee(123, "ashoke", "manager", 10001.00));
        empList.add(new Employee(424, "bharat", "lead", 10002.00));
        empList.add(new Employee(621, "chandu", "director", 10005.00));
        empList.add(new Employee(93, "danish", "developer", 10006.00));
        empList.add(new Employee(448, "eenadu", "developer", 10001.00));

        Consumer<Employee> names = n-> System.out.println(n.getName());
       //getNames from employee
        empList.forEach(names);

        //get complete List
        empList.forEach(System.out::println);


        Consumer<String> lower = s -> System.out.println(s.toLowerCase());
        Consumer<String> upper = s -> System.out.println(s.toUpperCase());
        Consumer<String> getChar = s -> System.out.println(s.charAt(2));
        //Consumer<Integer> intData = s->System.out.println(s+"123"); // cannot convert String to int

        /**
         * andThen
         * it will print all the above condition given
         */
        Consumer<String> output = lower.andThen(upper).andThen(getChar); // performing operation
        output.accept("ApplicaTion"); // input

        /**
         * BiConsumer
         * It takes 2 parameters
         */
        BiConsumer<String,String> x = (a,b)-> System.out.println("Consuming two parameters.. : "+a+"---"+b);
        x.accept("Hello", "java");
    }
}
