package lamda.first;


import lamda.userdefined.functional.interfaces.*;

public class Demo implements MyNumber, NumericTest, NumericTest2 {

    public static void main(String[] args) {

        //Lamda for fixed number
        MyNumber num = () -> 123.4;
        System.out.println("Fixed value is "+num.getValue());

        num = () -> Math.random();
        System.out.println("Random number is "+ num.getValue());
        System.out.println("Another random number is "+ num.getValue());

        //num = ()->"Hello Lamda"; // error

        // Without lamda
        Demo demo = new Demo();
        System.out.println(demo.getValue());

        //Numeric test , 2nd interface
        //lamda expression
        NumericTest isEven;

        isEven = i -> i%2 == 0 ;
        if(isEven.test(10))
            System.out.println("10 is an even number");
        if(!isEven.test(9))
            System.out.println("9 is not an even number");

        //chek for non negetive numbers
        NumericTest nonNeg;
        nonNeg = (i)->i>=0;
        if(nonNeg.test(3))
            System.out.println("3 is non negetive number");
        if(!nonNeg.test(-2))
            System.out.println("-2 is a negetive number");

        //Numeric Test 3rd interface
        NumericTest2 num2;
        num2 = (x,y) -> x>y;
        if(!num2.test(2,3))
            System.out.println("2 is not a greater number ");
        num2 = (x,y)-> x%y == 0;
        if(num2.test(10,2))
            System.out.println("Given number is a factorial");
        if(!num2.test(10,3))
            System.out.println("Given numbers are not Factorial");

        //BLOCK LAMDA DEMO

        NumericFunc numF ;
        numF = x -> {
            int result = 1;
            for(int i=1; i<=x ; i++){
                result = i* result;
            }
            return result;
        };
        System.out.println("Factorial of 3 is "+numF.func(3));
        System.out.println("Factorial of 6 is "+numF.func(6));

        // Reverse a string character
        StringFunc strF;

        strF = s->{
            String result = "";
            for(int i = s.length()-1; i>=0 ;i--){
                result = result+s.charAt(i);
            }
            return result;
        };
        System.out.println(strF.func("flag"));

        //GENERIC In Functional Interface

        SomeFunc<String> some = s->{
            String result = "";
            for(int i = s.length()-1; i>=0 ;i--){
                result = result+s.charAt(i);
            }
            return result;
        };
        System.out.println(some.somFun("stone"));

        SomeFunc<Integer> someNum = x -> {
            int result = 1;
            for(int i=1; i<=x ; i++){
                result = i* result;
            }
            return result;
        };
        System.out.println("Factorial of 3 is "+someNum.somFun(3));
        System.out.println("Factorial of 6 is "+someNum.somFun(6));

    }

    // Overridden methods not require if using Lamda expression
    @Override
    public double getValue() {
        // 'remove implements'
        // No overriding require
        // no object creation required for calling method
        return 123.44;
    }

    //Not required if using Lamda Expression
    @Override
    public boolean test(int i) {
        boolean flag = i%2 == 0;
        return flag;
    }

    @Override
    public boolean test(int x, int y) {
        //logic which returns boolean
        if(x>y){
            System.out.println("x is greater than y");
        }
        return false;
    }
}
