package lamda.function;

import java.util.Arrays;
import java.util.List;
import java.util.function.BiFunction;
import java.util.function.Function;

public class Example1 {

    public static void main(String[] args) {

        //example1
        Function<String, Integer> obj = s -> s.length();
        System.out.println("length is " + obj.apply("ambition"));

        //example2
        Function<Integer, String> function = i -> i * 1125 + " rupees on given sqft";
        System.out.println(function.apply(50));


        // andThen and compose examples
        Function<String, String> obj1 = x -> "first" + x;
        Function<String, String> obj2 = x -> "second" + x;

        //andThen
        Function<String, String> andThen1 = obj1.andThen(obj2);
        System.out.println("andThen Output1 : " + andThen1.apply("CheckObject"));

        Function<String, String> andThen2 = obj2.andThen(obj1);
        System.out.println("andThen Output2 : " + andThen2.apply("CheckObject"));

        //compose
        Function<String, String> compose1 = obj1.compose(obj2);
        System.out.println("compose Output1 : " + compose1.apply("CheckObject"));

        Function<String, String> compose2 = obj2.compose(obj1);
        System.out.println("compose Output2 : " + compose2.apply("CheckObject"));

        //The identity function in math is one in which the
        // output of the function is equal to its input.

        //BiFunction
        BiFunction<Integer, Integer, Integer> f1 = Integer::sum;
        System.out.println(f1.apply(34, 12)); //returns and print 46

        //a basic andThen() example with BiFunction
        Function<Integer, Integer> f2 = a -> a * a;
        System.out.println(f1.andThen(f2).apply(11, 13));
    }
}
