package lamda.function;

import lamda.pojo.Employee;

import java.util.ArrayList;
import java.util.List;
import java.util.function.Function;
import java.util.stream.Collectors;

public class Example2 {
    public static void main(String[] args) {


        //Employee List
        List<Employee> empList = new ArrayList<>();
        empList.add(new Employee(123, "ashoke", "manager", 10001.00));
        empList.add(new Employee(424, "bharat", "lead", 10002.00));
        empList.add(new Employee(621, "chandu", "director", 10005.00));
        empList.add(new Employee(93, "danish", "developer", 10006.00));
        empList.add(new Employee(448, "eenadu", "developer", 10001.00));

        //Without Streams
        Function<Employee, String> function = emp-> emp.getName();
        ArrayList<String> empNames = new ArrayList<>();

        for (Employee emp : empList) {
            empNames.add(function.apply(emp));
        }
        empNames.forEach(System.out::println);

        //Get Data WITH  Streams
        List<String> empNames1 = empList.stream().map(function).collect(Collectors.toList());
        //List<String> empNames1 = empList.stream().map(Employee::getName).collect(Collectors.toList());
        //List<String> empNames1 = empList.stream().map(e->e.getName()).collect(Collectors.toList());
        empNames1.forEach(e-> System.out.println(e+" : streams"));



    }
}
