package lamda.predicate;

import lamda.pojo.Employee;

import java.util.ArrayList;
import java.util.List;
import java.util.function.BiPredicate;
import java.util.function.Predicate;
import java.util.stream.Collectors;

public class Example2 {

    public static void main(String[] args) {
        //and conditions
        Predicate<Employee> isLead = e -> e.getDesignation().contains("lead");
        Predicate<Employee> highSalary = e->e.getSalary()>10000.00;

        Predicate<Employee> data = isLead.and(highSalary).and(e -> e.getAddress() != null).negate();

        //or
        boolean test = data.or(e -> e.getName().startsWith("b")).test(new Employee(424, "bharat", "lead", 10002.00));
        System.out.println("Is employee lead : "+test);

        //Employee List
        List<Employee> empList = new ArrayList<Employee>();
        empList.add(new Employee(123,"ashoke","manager",10001.00));
        empList.add(new Employee(424,"bharat","lead",10002.00));
        empList.add(new Employee(621,"chandu","director",10005.00));
        empList.add(new Employee(93,"danish","developer",10006.00));
        empList.add(new Employee(448,"eenadu","developer",10001.00));

        List<Employee> employeeList = empList.stream().filter(isLead).collect(Collectors.toList());

        //BiPredicate
        BiPredicate<Integer, Double> id = (x,y)-> x>400 && y<10006.00;
        List<Employee> employees = empList.stream().filter(input -> id.test(input.getEmpId(), input.getSalary())).collect(Collectors.toList());

        employees.forEach(System.out::println);

    }
}
