package nisum.rte.examples;

import java.util.*;
import java.util.stream.Collectors;
import java.util.stream.Stream;

import static java.util.stream.Collectors.toMap;

public class Demo {
    public static void main(String[] args) {

        Map<Integer, String> hashMap = new HashMap<>();
        hashMap.put(3,"apple");
        hashMap.put(4,"orange");
        hashMap.put(2,"banana");
        hashMap.put(9,"mango");
        hashMap.put(5,"leeche");



        TreeMap<Integer, String> map = new TreeMap<>();
        map.putAll(hashMap);

        for (Map.Entry<Integer,String> newEntry: map.entrySet()) {
            System.out.println("Unsorted Keys : "+ newEntry.getKey());
        }

        //java 8 sorting which returns Set
        Set<Integer> collect = hashMap.keySet().stream().sorted(Integer::compareTo).collect(Collectors.toCollection(LinkedHashSet::new));
        //System.out.println(collect);

        //Sorting returns map (Sort by Key)
        Stream<Map.Entry<Integer, String>> sortedStream = hashMap.entrySet().stream().sorted(Map.Entry.comparingByKey());
        //sortedStream.forEach(System.out::println);

        //Descending order
        LinkedHashMap<Integer, String> lhmDescendingOrder = hashMap.entrySet().stream().sorted(Collections.reverseOrder(Map.Entry.comparingByKey()))
                .collect(toMap(Map.Entry::getKey, Map.Entry::getValue, (x, y) -> y, LinkedHashMap::new));


        Set<Map.Entry<Integer, String>> entries = hashMap.entrySet(); // get entries then
        Stream<Map.Entry<Integer, String>> stream = entries.stream(); // get Stream
        Stream<Map.Entry<Integer, String>> sorted1 = stream.sorted(Map.Entry.comparingByKey());// expects one comparator
        //sorted1.forEach(System.out::println);

        //Sorting by Values and Collecting in new Map object
        LinkedHashMap<Object, Object> linkedHashMap = new LinkedHashMap<>();
        Stream<Map.Entry<Integer, String>> sorted2 = hashMap.entrySet().stream().sorted(Map.Entry.comparingByValue());

//        sorted2.forEach(x->linkedHashMap.put(x.getKey(),x.getValue()));
//        System.out.println("--------------------------------");
//        System.out.println(linkedHashMap);

        /**
         * Sort Keys in Ascending order
         */
        hashMap.entrySet().stream().sorted(Map.Entry.comparingByKey()).forEach(System.out::println);

        /**
         * Sort Keys in Descending order
         */
        hashMap.entrySet().stream().sorted(Collections.reverseOrder(Map.Entry.comparingByKey())).forEach(System.out::println);

    }
}
