package stream.basic;

import java.util.*;
import java.util.function.Function;
import java.util.stream.Collectors;

public class CollectorsDemo {
    public static void main(String[] args) {

        List<Integer> numbers = Arrays.asList(10, 20, 30, 11, 20, 33, 4, 44, 55, 20);
        System.out.println("original  :"+numbers);

        //Collectors.toSet
        Set<Integer> integerSet = numbers.stream().collect(Collectors.toSet());
        System.out.println("AfterSet  :"+integerSet);

        //Collectors.toList
        List<Integer> intList = numbers.stream().collect(Collectors.toList());
        System.out.println("AfterList  :"+intList);

        //Collectors.toCollection
        //creates any collection object
        ArrayList<Integer> array = numbers.stream().collect(Collectors.toCollection(ArrayList::new));

        //Collection.toMap
        //key will not add duplicates neither overrides, so using set as input
        Map<Integer, String> mapCollect = integerSet.stream().collect(Collectors.toMap(Function.identity(), String::valueOf));
        System.out.println(mapCollect);

        //Collectors.joining
        //Joins th input, return only String.
        String joined = numbers.stream().map(String::valueOf).collect(Collectors.joining("-"));
        System.out.println(joined);

        //Collestors.groupingBy
        Map<String, Set<Integer>> collect = numbers.stream().collect(Collectors.groupingBy(String::valueOf, Collectors.toSet()));
        System.out.println(collect);

        Optional<Integer> op= Optional.of(9455);
        op.isPresent();

    }
}
